"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderServer = exports.render = exports.readPageHtml = exports.checkModules = void 0;
var _fs = require("fs");
var _serverRenderer = require("@vue/server-renderer");
var _serializeJavascript = require("serialize-javascript");
var _vue3Webpack = require("@srejs/vue3-webpack");
var _common = _interopRequireWildcard(require("@srejs/common"), true);
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator["return"] && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, "catch": function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
/**
 * 用Promise封装异步读取文件方法
 * @param  {string} page html文件名称
 * @return {promise}
 */
var readPageHtml = exports.readPageHtml = function readPageHtml(page) {
  return new Promise( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(resolve, reject) {
      var viewUrl, readFileSync, htmlString;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            viewUrl = "".concat(_common.clientDir, "/").concat(page, "/").concat(page, ".html");
            readFileSync = function readFileSync() {
              _fs.readFile(viewUrl, 'utf8', function (err, htmlString) {
                if (err) {
                  reject(err);
                  _common.Logger.error('SSR: The client code is being compiled, please refresh the browser later...');
                } else {
                  resolve(htmlString);
                }
              });
            };
            if (_common["default"].isDev()) {
              try {
                htmlString = _vue3Webpack.VueDevMiddlewareFileSystem.readFileSync(viewUrl, 'utf-8');
                resolve(htmlString);
              } catch (error) {
                readFileSync();
              }
            } else {
              readFileSync();
            }
          case 3:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
};

/**
 *  生成环境编译代码检查
 * @param {*} page
 * @returns
 */
var checkModules = exports.checkModules = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(page) {
    var jspath, jsClientdir, compiler, _compiler;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          jspath = "".concat(_common.serverDir, "/").concat(page, "/").concat(page, ".js");
          jsClientdir = "".concat(_common.clientDir, "/").concat(page);
          if (_fs.existsSync(jspath)) {
            _context2.next = 6;
            break;
          }
          //服务端代码打包
          compiler = new _vue3Webpack.WebpackVue(page, _common["default"].isDev(), true);
          _context2.next = 6;
          return compiler.run();
        case 6:
          if (!(!_fs.existsSync(jsClientdir) && !_common["default"].isDev())) {
            _context2.next = 10;
            break;
          }
          //客户端代码打包
          _compiler = new _vue3Webpack.WebpackVue(page, _common["default"].isDev());
          _context2.next = 10;
          return _compiler.run();
        case 10:
          return _context2.abrupt("return", jspath);
        case 11:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function checkModules(_x3) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * Router类型页面渲染解析
 * @param {*} ctx
 * @param {*} next
 */
var renderServer = exports.renderServer = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(ctx) {
    var initProps,
      ssr,
      context,
      _ctx$SSRKEY,
      page,
      query,
      path,
      options,
      Html,
      createApp,
      jspath,
      App,
      document,
      _args3 = arguments;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          initProps = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
          ssr = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : true;
          context = {
            url: ctx.req.url
          };
          _ctx$SSRKEY = ctx[_common.SSRKEY], page = _ctx$SSRKEY.page, query = _ctx$SSRKEY.query, path = _ctx$SSRKEY.path, options = _ctx$SSRKEY.options;
          path = encodeURI(path);
          query = (0, _common.filterXssByJson)(query);
          if ((0, _vue3Webpack.getVueEntryList)().has(page)) {
            _context3.next = 8;
            break;
          }
          return _context3.abrupt("return", "Page component ".concat(page, " does not exist, please check the pages folder"));
        case 8:
          if (_typeof(initProps) === 'object') {
            context = Object.assign({
              title: '',
              meta: ''
            }, context, initProps);
          }
          context.ssrData = {
            page: page,
            path: path,
            query: query,
            options: options
          };
          Html = '';
          if (!ssr) {
            _context3.next = 35;
            break;
          }
          _context3.next = 14;
          return checkModules(page);
        case 14:
          jspath = _context3.sent;
          try {
            // eslint-disable-next-line no-undef
            if (_common["default"].isDev()) {
              delete require.cache[require.resolve(jspath)];
            }
            createApp = require(jspath);
            createApp = createApp["default"] ? createApp["default"] : createApp;
          } catch (error) {
            // eslint-disable-next-line no-console
            _common.Logger.error("SSR: ".concat(page, "\u9875\u9762\u670D\u52A1\u7AEF\u52A0\u8F7D\u5165\u53E3\u6587\u4EF6\u5F02\u5E38\uFF0C\u8BF7\u68C0\u67E5\u662F\u5426\u5728\u4EE3\u7801\u7A0B\u5E8F\u4E2D\u4F7F\u7528\u5230\u6D4F\u89C8\u5668\u5BBF\u4E3B\u5BF9\u8C61\u7279\u5B9A\u7684API(\u5305\u62EC\u7B2C\u4E09\u65B9\u6A21\u5757\u9700\u652F\u6301SSR\u6A21\u5F0F\u5B89\u88C5)\n             Please check whether there are api in the code that the server does not support when rendering,\n             such as window, locaction, navigator, etc"));
            _common.Logger.error(error.stack);
          }
          _context3.prev = 16;
          _context3.next = 19;
          return createApp(context);
        case 19:
          App = _context3.sent;
          _context3.next = 22;
          return renderTostringVueNext(App, context, page);
        case 22:
          Html = _context3.sent;
          _context3.next = 33;
          break;
        case 25:
          _context3.prev = 25;
          _context3.t0 = _context3["catch"](16);
          ctx[_common.SSRKEY].options.ssr = false;
          context.ssrData = {
            page: page,
            path: path,
            query: query,
            options: options
          }; // 修正数据
          _common.Logger.warn("SSR: \u670D\u52A1\u7AEF\u6E32\u67D3\u5F02\u5E38\uFF0C\u964D\u7EA7\u4F7F\u7528\u5BA2\u6237\u7AEF\u6E32\u67D3:".concat(_context3.t0.stack));
          _context3.next = 32;
          return readPageString(page, context);
        case 32:
          Html = _context3.sent;
        case 33:
          _context3.next = 38;
          break;
        case 35:
          _context3.next = 37;
          return readPageString(page, context);
        case 37:
          Html = _context3.sent;
        case 38:
          document = (0, _common.renderDocumentHead)(Html, context);
          return _context3.abrupt("return", document);
        case 40:
        case "end":
          return _context3.stop();
      }
    }, _callee3, null, [[16, 25]]);
  }));
  return function renderServer(_x4) {
    return _ref3.apply(this, arguments);
  };
}();

/**
 * 客户端渲染时直接读取HTML注入变量
 * @param {*} page
 * @param {*} context
 * @returns
 */
var readPageString = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(page, context) {
    var temp;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          _context4.next = 2;
          return readPageHtml(page);
        case 2:
          temp = _context4.sent;
          return _context4.abrupt("return", injectScriptInitProps(temp, context));
        case 4:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function readPageString(_x5, _x6) {
    return _ref4.apply(this, arguments);
  };
}();

/**
 * vue3.0 服务端渲染解析DOM
 * @param {*} App
 * @param {*} context
 * @param {*} page
 * @returns
 */
var renderTostringVueNext = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(App, context, page) {
    var rootNode, html, appContent;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          rootNode = context.ssrData.options.rootNode;
          _context5.next = 3;
          return readPageString(page, context);
        case 3:
          html = _context5.sent;
          _context5.next = 6;
          return (0, _serverRenderer.renderToString)(App)["catch"](function (e) {
            console.log(e.stack);
          });
        case 6:
          appContent = _context5.sent;
          html = html.toString().replace("<div id=\"".concat(rootNode, "\">"), "<div id=\"".concat(rootNode, "\">").concat(appContent));
          return _context5.abrupt("return", html);
        case 9:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return function renderTostringVueNext(_x7, _x8, _x9) {
    return _ref5.apply(this, arguments);
  };
}();

/**
 * 在HTML中注入__SSR_DATA__
 * @param {*} temp
 * @param {*} context
 * @returns
 */
var injectScriptInitProps = function injectScriptInitProps(temp, context) {
  var contents = temp.split('</body>');
  if (contents.length == 1) {
    console.error('SSR:警告！vue3.0自定义html文件中必须包含</body>闭合标签。');
  }
  var data = Object.assign({}, context);
  var ssrData = data.ssrData;
  var initState = data.state;
  delete data.state;
  delete data.ssrData;
  delete context.ssrData;
  ssrData.initProps = data;
  return contents[0] + '<script>window.__INITIAL_STATE__=' + _serializeJavascript(initState, {
    isJSON: true
  }) + '</script>' + '<script>window.__SSR_DATA__=' + _serializeJavascript(ssrData, {
    isJSON: true
  }) + '</script>' + '</body>' + contents[1];
};
/**
 * 获取服务端渲染直出资源
 * @param {*} ctx
 */
var render = exports.render = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(ctx, initProps) {
    var page, _ctx$SSRKEY$options, cache, ssr;
    return _regeneratorRuntime().wrap(function _callee7$(_context7) {
      while (1) switch (_context7.prev = _context7.next) {
        case 0:
          page = ctx[_common.SSRKEY].page;
          _ctx$SSRKEY$options = ctx[_common.SSRKEY].options, cache = _ctx$SSRKEY$options.cache, ssr = _ctx$SSRKEY$options.ssr;
          return _context7.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(resolve) {
              var ssrCacheDir, ssrCacheUrl, rs, document;
              return _regeneratorRuntime().wrap(function _callee6$(_context6) {
                while (1) switch (_context6.prev = _context6.next) {
                  case 0:
                    if (ssr) {
                      _context6.next = 6;
                      break;
                    }
                    _context6.t0 = resolve;
                    _context6.next = 4;
                    return renderServer(ctx, initProps, false);
                  case 4:
                    _context6.t1 = _context6.sent;
                    return _context6.abrupt("return", (0, _context6.t0)(_context6.t1));
                  case 6:
                    ssrCacheDir = "".concat(_common.cacheDir).concat(ctx.url, "/");
                    ssrCacheUrl = "".concat(_common.cacheDir).concat(ctx.url, "/").concat(page, ".html");
                    if (!(_common["default"].isDev() || !cache)) {
                      _context6.next = 16;
                      break;
                    }
                    _context6.t2 = resolve;
                    _context6.next = 12;
                    return renderServer(ctx, initProps, true);
                  case 12:
                    _context6.t3 = _context6.sent;
                    return _context6.abrupt("return", (0, _context6.t2)(_context6.t3));
                  case 16:
                    if (!_fs.existsSync(ssrCacheUrl)) {
                      _context6.next = 21;
                      break;
                    }
                    // ssr缓存模式，执行一次ssr 第二次直接返回缓存后的html静态资源
                    rs = _fs.createReadStream(ssrCacheUrl, 'utf-8');
                    return _context6.abrupt("return", resolve(rs));
                  case 21:
                    _context6.next = 23;
                    return renderServer(ctx, initProps, true);
                  case 23:
                    document = _context6.sent;
                    process.nextTick(function () {
                      (0, _common.writeCacheSsr)(ssrCacheDir, ssrCacheUrl, document); //异步写入服务器缓存目录
                    });
                    return _context6.abrupt("return", resolve(document));
                  case 26:
                  case "end":
                    return _context6.stop();
                }
              }, _callee6);
            }));
            return function (_x12) {
              return _ref7.apply(this, arguments);
            };
          }()));
        case 3:
        case "end":
          return _context7.stop();
      }
    }, _callee7);
  }));
  return function render(_x10, _x11) {
    return _ref6.apply(this, arguments);
  };
}();